local screenW, screenH = guiGetScreenSize()
local x, y = (screenW/1366), (screenH/768)

local custom_fonts = {
	regular = dxCreateFont('files/regular.ttf', x * 10)
}

local infobox = {}
local margin = 1

addEventHandler('onClientRender', root,
	function()
		for i, info in ipairs(infobox) do
			local previous = infobox[i - 1]
			if (i > 3) then 
				table.remove(infobox, 1)
			end

			if (getTickCount() - info.tick > 10 * 650) then
				table.remove(infobox, 1)
			end

			local updateY = (isPedInVehicle(localPlayer) and 520 or 720)

			local posAct = {y = (y * (updateY - info.pos.h)), h = (y * (35 + info.pos.h))}
			if (previous) and (previous.posAct) then
				local prePosAct = previous.posAct
				posAct.y = prePosAct.y - posAct.h - margin
			end
			info.posAct = posAct

			local progress = interpolateBetween(0, 0, 0, 226, 0, 0, (getTickCount() - info.tick) / (9 * 650), 'Linear')
			local animation = interpolateBetween ((0 - 30), 0, 0, 15, 0, 0, (getTickCount ( ) - info.tick)/350, 'OutQuad')
			local animationText = interpolateBetween ((0 - 30), 0, 0, 25, 0, 0, (getTickCount ( ) - info.tick)/350, 'OutQuad')

			dxDrawRectangle(x * animation, posAct.y, x * 226, posAct.h, tocolor(info.color[1], info.color[2], info.color[3], info.alpha), true)
			dxDrawRectangle(x * animation, posAct.y, x * progress, posAct.h, tocolor(info.colorProgress[1], info.colorProgress[2], info.colorProgress[3], info.alpha), true)
			dxDrawText(info.message, x * animationText, posAct.y + 3, x * 225, y * (517 + info.pos.h), tocolor(255, 255, 255, info.alpha), 1, custom_fonts.regular, 'left', 'top', false, true, true, false, false)

			if ((getTickCount() - info.tick) >= (10 * 650) - 650) then
				if (not info.fadeOutTick) then
					info.fadeOutTick = getTickCount()
				end
				local alpha = interpolateBetween(230, 0, 0, 0, 0, 0, (getTickCount() - info.fadeOutTick) / 650, 'Linear')
				info.alpha = alpha
			end
		end
	end
)

function addBox(text, type)
	local textW, textH = dxGetTextSize(text, x * (269 - x * 85), 1, 1, custom_fonts.regular, true, false)
	local text = tostring(text)

	local self = setmetatable({
		message = text,
		dup = 1,
		color = {},
		colorProgress = {},
		pos = {
			x = textW,
			h = textH,
		},
		alpha = 230,
		tick = getTickCount(),
		tickAnim = getTickCount ( ),
		style = type,
	}, infobox)

	for i, info in ipairs(infobox) do
		if (info.dup > 1) then
			if (info.message == text..' x'..tonumber(info.dup)) then
				table.remove(infobox, i)
				if (self) then
					self.tick = info.tick
					self.alpha = info.alpha
					self.dup = info.dup + 1
					self.message = text..' x'..tonumber(self.dup)
				end
			end
		else
			if (info.message == text) then
				table.remove(infobox, i)
				if (self) then
					self.tick = info.tick
					self.alpha = info.alpha
					self.dup = info.dup + 1
					self.message = text..' x'..tonumber(self.dup)
				end
			end
		end
	end

	if (self) then
		if (self.style == 'error') then
			self.color = {231, 94, 87}
			self.colorProgress = {236, 110, 101}
			playSound('files/error.wav')
		elseif (self.style == 'success') then
			self.color = {123, 128, 62}
			self.colorProgress = {131, 137, 78}
			playSound('files/star.wav')
		elseif (self.style == 'info') then
			self.color = {56, 123, 143}
			self.colorProgress = {77, 140, 159}
			playSound('files/bulle.wav')
		elseif (self.style == 'warning') then
			self.color = {67, 8, 121}
			self.colorProgress = {67, 40, 121}
			playSound('files/victory.wav')
		elseif (self.style == 'staff') then
			self.color = {219, 115, 9}
			self.colorProgress = {219, 149, 0}
			playSound('files/victory.wav')
		elseif (self.style == 'anuncio') then
			self.color = {45, 112, 214}
			self.colorProgress = {45, 70, 189}
			playSound('files/victory.wav')
		end
		table.insert(infobox, self)
		outputConsole('['..type..'] '..text)
	end
	return self
end
addEvent('addBox', true)
addEventHandler('addBox', getRootElement(), addBox)