--[[
███╗░░░███╗███████╗██╗░░░░░░█████╗░  ░██████╗░█████╗░██████╗░
████╗░████║██╔════╝██║░░░░░██╔══██╗  ██╔════╝██╔══██╗██╔══██╗
██╔████╔██║█████╗░░██║░░░░░██║░░██║  ╚█████╗░██║░░╚═╝██████╔╝
██║╚██╔╝██║██╔══╝░░██║░░░░░██║░░██║  ░╚═══██╗██║░░██╗██╔══██╗
██║░╚═╝░██║███████╗███████╗╚█████╔╝  ██████╔╝╚█████╔╝██║░░██║
╚═╝░░░░░╚═╝╚══════╝╚══════╝░╚════╝░  ╚═════╝░░╚════╝░╚═╝░░╚═╝
]]

screenW, screenH = guiGetScreenSize()
local x, y = (screenW / 1366), (screenH / 768)
g_StreamedInPlayers = {}

voiceOn = {}

addEventHandler('onClientPlayerVoiceStart', root,
	function()
		if (source == localPlayer) then
            setElementData(localPlayer, "MeloSCR:Falando", true)
		end
	end
)

addEventHandler('onClientPlayerVoiceStop', root,
	function()
		if (source == localPlayer) then
            setElementData(localPlayer, "MeloSCR:Falando", false)
		end
	end
)

addEventHandler("onClientRender", root, 
function ()
    if not getElementData(localPlayer, "MeloSCR:StaffAtivo") then 
        for i,v in ipairs(getElementsByType("player", getRootElement(), true)) do 
            if v ~= localPlayer then
                local bX, bY, bZ = getPedBonePosition(v, 4)
                local dist = getDistanceBetweenPoints3D(Vector3(getElementPosition(localPlayer)), bX, bY, bZ)
                if dist <= config.distanciaVerIDS and isLineOfSightClear(Vector3(getElementPosition(localPlayer)), bX, bY, bZ, true, false, false, true) and not getElementData(v, "MeloSCR:StaffAtivo") then
                    local screen = {getScreenFromWorldPosition(bX + 0.04, bY, bZ + 0.35)}
                    if screen[1] and screen[2] then 
                        local tagInfos = getTagInfos(v)
                        local IDp = getElementData(v, "ID") or "N/A"
                        local w = dxGetTextWidth(IDp, 0.1, "default")
                        local h = dxGetFontHeight(1, "default")
                        dxDrawText(tagInfos[3].."("..IDp..")"..tagInfos[2], screen[1] - 30 - w / 1 + 1, screen[2] - 20 - h - 2 + 1, w, h, tocolor(255, 255, 255), 1, "default", "left", "top", false, false, false, true, false)
                        if tagInfos[4] then 
                            dxDrawImage(screen[1] - 1 - w / 1 + 1 + tagInfos[4][1], screen[2] - 1 - h - 2 + 1 + tagInfos[4][2], x * tagInfos[4][3], y * tagInfos[4][4], tagInfos[4][5], tagInfos[4][6], tagInfos[4][7], tagInfos[4][8], tagInfos[4][9])
                        end     
                    end 
                end 
            end 
        end 
    else 
        for i,v in ipairs(getElementsByType("player")) do 
            if v ~= localPlayer then
                local bX, bY, bZ = getElementPosition(v)
                local screen = {getScreenFromWorldPosition(bX + 0.04, bY, bZ + 0.35)}
                if screen[1] and screen[2] then 
                    local tagInfos = getTagInfos(v)
                    local IDp = getElementData(v, "ID") or "N/A"
                    local w = dxGetTextWidth(IDp, 0.1, "default")
                    local h = dxGetFontHeight(1, "default")
                    dxDrawText(tagInfos[3]..removeHex(getPlayerName(v)).."("..IDp..")"..tagInfos[2], screen[1] - 30 - w / 1 + 1, screen[2] - 1 - h - 2 + 1, w, h, tocolor(255, 255, 255), 1, "default", "left", "top", false, false, false, true, false)
                end 
            end 
        end 
    end 
end)

----------------------------------------------------UTIL----------------------------------------------------

function onClientElementStreamIn()
	if getElementType(source) == "player" and source ~= getLocalPlayer() then
		setPlayerNametagShowing(source, false)
		table.insert(g_StreamedInPlayers, source)
	end
end
addEventHandler("onClientElementStreamIn", root, onClientElementStreamIn)

function onClientResourceStart(startedResource)
	visibleTick = getTickCount()
	counter = 0
	local players = getElementsByType("player")
	for k, v in pairs(players) do
		if isElementStreamedIn(v) and v ~= getLocalPlayer() then
			setPlayerNametagShowing(v, false)
			table.insert(g_StreamedInPlayers, v)
		end
	end
end
addEventHandler("onClientResourceStart", resourceRoot, onClientResourceStart)

function getTagInfos(thePlayer)
    for i,v in ipairs(config.Tags) do 
        if getElementData(thePlayer, v[1]) then 
            return v
        elseif i == #config.Tags then 
            return {"", "", ""}
        end 
    end 
end 

function isEventHandlerAdded( sEventName, pElementAttachedTo, func )
    if type( sEventName ) == 'string' and isElement( pElementAttachedTo ) and type( func ) == 'function' then
        local aAttachedFunctions = getEventHandlers( sEventName, pElementAttachedTo )
        if type( aAttachedFunctions ) == 'table' and #aAttachedFunctions > 0 then
            for i, v in ipairs( aAttachedFunctions ) do
                if v == func then
                    return true
                end
            end
        end
    end
    return false
end

function isMouseInPosition ( x, y, width, height )
	if ( not isCursorShowing( ) ) then
		return false
	end
	local sx, sy = guiGetScreenSize ( )
	local cx, cy = getCursorPosition ( )
	local cx, cy = ( cx * sx ), ( cy * sy )
	
	return ( ( cx >= x and cx <= x + width ) and ( cy >= y and cy <= y + height ) )
end


notifyC = function (message, type)
    if config.Notify.export then 
        call(getResourceFromName(config.Notify.nomescriptouevento), config.Notify.funcaoexport,message, type)
    else 
        triggerEvent(config.Notify.nomescriptouevento, localPlayer, message, type)
    end 
end