local settings = {
    visible = false,
    group = false,
    cooldown = false
}

local scroll = {
    pag = 0,
    select = 0,
    max = 6
}

local animations = {
    alpha = {0, 255}
}

local assets = ':'..config.Geral.PasteAssets

local alpha = 0
function Manager ()
    alpha = interpolate (animations.alpha[1], animations.alpha[2], 0.07, 'alpha')

    dxDrawImage (531, 216, 304, 366, svg.home, 0, 0, 0, tocolor (255, 255, 255, alpha))
    dxDrawImage (564, 228, 40, 40, 'me/assets/image/prancheta.png', 0, 0, 0, tocolor (255, 255, 255, alpha))
    dxDrawImage (557, 535, 125, 33, svg.submit, 0, 0, 0, (isCursorOnElement (557, 535, 125, 33) and tocolor (settings.group.Color[1], settings.group.Color[2], settings.group.Color[3], alpha / 1.3) or tocolor (28, 28, 28, alpha)))
    dxDrawImage (686, 535, 125, 33, svg.submit, 0, 0, 0, (isCursorOnElement (686, 535, 125, 33) and tocolor (settings.group.Color[1], settings.group.Color[2], settings.group.Color[3], alpha / 1.3) or tocolor (28, 28, 28, alpha)))
    dxDrawText ('ADICIONAR', 557, 535, 125, 33, tocolor (255, 255, 255, alpha), 1.00, dxCreateFont (assets..'/assets/font/RobotoCondensed/RobotoCondensed-Regular.ttf', 9), 'center', 'center')
    dxDrawText ('REMOVER', 686, 535, 125, 33, tocolor (255, 255, 255, alpha), 1.00, dxCreateFont (assets..'/assets/font/RobotoCondensed/RobotoCondensed-Regular.ttf', 9), 'center', 'center')
    dxDrawText ('TAGS - '..string.upper (settings.group.PanelName), 531, 228, 304, 40, tocolor (255, 255, 255, alpha), 1.00, dxCreateFont (assets..'/assets/font/RobotoCondensed/RobotoCondensed-Medium.ttf', 12), 'center', 'center')
    dxCreateEditbox('id', {554, 288, 259, 34}, 10, {tocolor(255, 255, 255, alpha), tocolor(0, 0, 0, 0)}, (dxCreateFont (assets..'/assets/font/RobotoCondensed/RobotoCondensed-Medium.ttf', 10) or 'sans'), 'ID', false, false, true, false)
    for key = 1, scroll.max do
        local values = settings.group.Tags[key + scroll.pag]
        if values then
            local posY = (335 + 29 * key - 29)
            dxDrawRectangle (554, posY, 259, 29, (isCursorOnElement (554, posY, 259, 29) and tocolor (settings.group.Color[1], settings.group.Color[2], settings.group.Color[3], alpha / 1.3) or (key + scroll.pag) == scroll.select and tocolor (settings.group.Color[1], settings.group.Color[2], settings.group.Color[3], alpha / 1.3) or tocolor (0, 0, 0, 0)))
            dxDrawText ((values and tostring (values.name) or 'undefined'), 554, posY, 259, 29, tocolor (255, 255, 255, alpha), 1.00, dxCreateFont (assets..'/assets/font/RobotoCondensed/RobotoCondensed-Regular.ttf', 10), 'center', 'center')
        end
    end
end

function togglePanel (toggle, group)
    if settings.cooldown then
        return
    end
    settings.cooldown = setTimer (function ()
        if settings.cooldown and isTimer (settings.cooldown) then
            killTimer (settings.cooldown)
            settings.cooldown = false
        end
    end, 800, 1)
    if toggle then
        if settings.visible then
            return
        end
        settings.visible = true
        settings.group = group
        scroll.select = false
        scroll.pag = 0
        animations.alpha = {alpha, 255}
        showCursor (true)
        addEventHandler ('onClientRender', getRootElement (), Manager, true, 'normal')
        return
    end
    if not toggle then
        if not settings.visible then
            return
        end
        settings.visible = false
        animations.alpha = {alpha, 0}
        setTimer (function ()
            showCursor (false)
            settings.group = false
            dxEditboxDestroyAll ()
            removeEventHandler ('onClientRender', getRootElement (), Manager, true, 'normal')
        end, 800, 1)
        return
    end
end

addEventHandler ('onClientClick', getRootElement (), function (button, state)
    if not settings.visible then
        return    
    end
    if button == 'left' and state == 'down' then
        if isCursorOnElement (557, 535, 125, 33) or isCursorOnElement (686, 535, 125, 33) then
            if dxEditboxGetText('id').len == 0 then
                sendMessage ('client', 'Insira o ID do jogador que deseja setar a tag.', 'info')
                return
            end
            if not scroll.select or scroll.select  == 0 then
                sendMessage ('client', 'Selecione a TAG que deseja setar.', 'info')
                return
            end
            local method = (isCursorOnElement (557, 535, 125, 33) and 'Add' or 'Remove')
            triggerServerEvent ('request:manager', localPlayer, method, dxEditboxGetText('id').content, settings.group.Tags[scroll.select])
            return
        end
        if not isCursorOnElement (531, 216, 304, 366) then
            scroll.select = 0
            return
        end
        for key = 1, scroll.max do
            local values = settings.group.Tags[key + scroll.pag]
            if values then
                local posY = (335 + 29 * key - 29)
                if isCursorOnElement (554, posY, 259, 29) then
                    scroll.select = (key + scroll.pag)
                    break
                end
            end
        end
    end
end)

addEvent ('manager:toggle', true)
addEventHandler ('manager:toggle', getRootElement (), function (group)
    togglePanel (not settings.visible, group)
    return
end)

function scrollbar (button)
    if not settings.visible then
        return
    end
    if button == 'mouse_wheel_up' then
        if scroll.pag > 0 then
            scroll.pag = scroll.pag - 1
        end
    end
    if button == 'mouse_wheel_down' then
        if (#settings.group.Tags- scroll.max) > 0 then
            scroll.pag = scroll.pag + 1 
            if (scroll.pag > (#settings.group.Tags- scroll.max)) then
                scroll.pag = (#settings.group.Tags- scroll.max)
            end
        end
    end
end

bindKey ('mouse_wheel_up', 'down', scrollbar)
bindKey ('mouse_wheel_down', 'down', scrollbar)