addEventHandler ('onResourceStart', resourceRoot, function (resource)
    local assets = config.Geral.PasteAssets
    local resource_assets = getResourceFromName (assets)
    if not resource_assets then
        cancelEvent (true)
        outputDebugString (getResourceName (resource)..": O resource '"..assets.."' não foi encontrado.", 4, 255, 50, 50)
        return
    end
    if getResourceState (resource_assets) ~= 'running' then
        cancelEvent (true)
        outputDebugString (getResourceName (resource)..": Primeiro inicie o resource '"..assets.."'.", 4, 255, 50, 50)
        return
    end
    return outputDebugString (getResourceName (resource)..': Gerenciador de Tags Initialized.', 4, 0, 255, 50)
end)

addEventHandler ('onPlayerCommand', getRootElement (), function (command)
    if not config.Commands[string.lower (command)] then
        return
    end
    local details = config.Commands[string.lower (command)]
    if not isPlayerInACL (source, details.Acl) then
        return false
    end
    triggerClientEvent (source, 'manager:toggle', source, details)
    return
end)

addEvent ('request:manager', true)
addEventHandler ('request:manager', getRootElement (), function (...)
    local result = {...}
    if not result[3] then
        return
    end
    if result[1] == 'Add' then
        local receiver = getPlayerFromID (result[2])

        if not receiver then
            sendMessage ('server', source, 'Jogador não encontrado.', 'info')
            return
        end
        if isPlayerInACL (receiver, result[3].acl) then
            sendMessage ('server', source, 'O jogador ja está na ACL.', 'info')
            return
        end
        if getPlayerInACLTable (receiver, Blocks[result[3].acl]) then
            return sendMessage ('server', source, 'O jogador ja está em uma organização.', 'error')
        end
        if aclGroupAddObject (aclGetGroup (result[3].acl), 'user.'..getAccountName (getPlayerAccount (receiver))) then
            sendMessage ('server', source, 'Você adicionou o jogador: '..getPlayerName (receiver)..' ('..result[2]..') no grupo: '..result[3].name..'.', 'success')
            sendDiscordEmbed ({value = 'Jogador: '.. (getPlayerName (source)) ..' ('.. (getElementData (source, 'ID') or 0) ..')\nRemetente: '.. getPlayerName (receiver) ..' ('.. (getElementData (receiver, 'ID') or 0) ..')\nGrupo: '.. result[3].acl ..'\nAção: Adicionar', name = result[3].name})
            return
        end
        return sendMessage ('server', source, 'Erro ao adicionar o jogador neste Grupo.', 'error')
    end
    if result[1] == 'Remove' then
        if not getPlayerFromID (result[2]) then
            sendMessage ('server', source, 'Jogador não encontrado.', 'info')
            return
        end
        local receiver = getPlayerFromID (result[2])
        if not isPlayerInACL (receiver, result[3].acl) then
            sendMessage ('server', source, 'O jogador não está na ACL.', 'info')
            return
        end
        if aclGroupRemoveObject (aclGetGroup (result[3].acl), 'user.'..getAccountName (getPlayerAccount (receiver))) then
            sendMessage ('server', source, 'Você removeu o jogador: '..getPlayerName (receiver)..' ('..result[2]..') no grupo: '..result[3].name..'.', 'success')
            sendDiscordEmbed ({value = 'Jogador: '.. (getPlayerName (source)) ..' ('.. (getElementData (source, 'ID') or 0) ..')\nRemetente: '.. getPlayerName (receiver) ..' ('.. (getElementData (receiver, 'ID') or 0) ..')\nGrupo: '.. result[3].acl ..'\nAção: Remover', name = result[3].name})
            return
        end
        return sendMessage ('server', source, 'Erro ao remover o jogador deste Grupo.', 'error')
    end
end)